﻿import-module Activedirectory
function ConnectMySQL([string]$user,[string]$pass,[string]$MySQLHost,[string]$database) {
	# Load MySQL .NET Connector Objects  
	[void][system.reflection.Assembly]::LoadFrom("C:\Program Files (x86)\MySQL\MySQL Connector Net 6.5.4\Assemblies\v2.0\MySQL.Data.dll")   
	# Open Connection  
	$connStr = "server=" + $MySQLHost + ";port=3306;uid=" + $user + ";pwd=" + $pass + ";database="+$database+";Pooling=FALSE"  
	$conn = New-Object MySql.Data.MySqlClient.MySqlConnection($connStr)  
	$conn.Open() 
	$cmd = New-Object MySql.Data.MySqlClient.MySqlCommand("USE $database", $conn)  
	return $conn 
}

function WriteMySQLQuery($conn, [string]$query) {
	$command = $conn.CreateCommand()  
	$command.CommandText = $query  
	$RowsInserted = $command.ExecuteNonQuery()  
	$command.Dispose()  
	if ($RowsInserted) {    
		return $RowInserted  
	} 
	else {    
		return $false  
	}
}
# setup vars
$user = 'itpwd'
$pass = 'itpwd'
$database = 'auditad'
$MySQLHost = '10.1.1.1'
$conn = ConnectMySQL $user $pass $MySQLHost $database

# Event id references
# 4728/4729 > A member was added/removed to/from a security-enabled global group
# 4732/4733 > A member was added/removed to/from a security-enabled local group
# 4756/4757 > A member was added/removed to/from a security-enabled universal group
# 4751/4752 > A member was added/removed to/from a security-disabled global group (distribution list)
# 4746/4747 > A member was added/removed to/from a security-disabled local group (distribution list)
# 4761/4762 > A member was added/removed to/from a security-disabled universal group (distribution list)
$eventid_grp_chg = "4728","4729","4732","4733","4756","4757","4751","4752","4746","4747","4761","4762"

# 4727/4749	> A security-enabled/disabled global group was created
# 4731/4744 > A security-enabled/disabled local group was created
# 4754/4759 > A security-enabled/disabled universal group was created
# 4730/4753	> A security-enabled/disabled global group was deleted
# 4734/4748 > A security-enabled/disabled local group was deleted
# 4758/4763 > A security-enabled/disabled universal group was deleted
$eventid_grp = "4727","4749","4731","4744","4754","4759","4730","4753","4734","4748","4758","4763"

# 4720 		> A user account was created
# 4722 		> A user account was enabled
# 4723 		> An attempt was made to change an account's password
# 4724 		> An attempt was made to reset an accounts password
# 4725 		> A user account was disabled
# 4726 		> A user account was deleted
# 4738 		> A user account was changed
# 4740 		> A user account was locked out
# 4767 		> A user account was unlocked
# 4781 		> The name of an account was changed
$eventid_usr_chg = "4720","4722","4723","4724","4725","4726","4738","4740","4767","4781"

# 5136 		> A directory service object was modified
# 5137 		> A directory service object was created
# 5138 		> A directory service object was undeleted
# 5139 		> A directory service object was moved
# 5141 		> A directory service object was deleted
$eventid_pol = "5136","5137","5138","5139","5141"

$event_arr = get-eventlog -LogName Security -After (get-date).addminutes(-60) -EntryType SuccessAudit `
| where	{($eventid_grp_chg -contains $_.eventid) `
		-or ($eventid_grp -contains $_.eventid) `
		-or ($eventid_usr_chg -contains $_.eventid) `
		-or (($eventid_pol -contains $_.eventid) -and ($_.message.Contains("groupPolicyContainer")))} `
| Foreach-Object {	($_.timegenerated).ToString("MM.dd.yyyy HH:mm:ss") + ";" + `
					($_.eventid).tostring() + ";" + `
					((($_.message -replace "`n", ";") -replace ";`t","") -replace "`r",";")}

if ($event_arr){
foreach ($event in $event_arr) {
	$date = $event.split(";")[0]
	$id = $event.split(";")[1]
	$desc = $event.split(";")[2]
	$change = $event.split(";")[16]
	$change = ($change.Substring(13)).trim()
	$modifiedby = $event.split(";")[8]
	$modifiedby = ($modifiedby.Substring(13)).trim()

	switch ($id){
		{$eventid_grp_chg -contains $_} {
			$change_obj = $event.split(";")[22]
			$change_obj = ($change_obj.Substring(11)).trim()
			Write-Host "grp chg"
		}
		{$eventid_grp -contains $_} {
			$change_obj = $event.split(";")[16]
			$change_obj = ($change_obj.Substring(11)).trim()
		}
		{($_ -eq "4722") -or ($_ -eq "4723") -or ($_ -eq "4724") -or ($_ -eq "4725") -or ($_ -eq "4726") -or ($_ -eq "4767")}  {
			$change_obj = ""
		}
		{($_ -eq "4738") -or ($_ -eq "4720")} {
			$change_obj = (($event.split(";")[22..33]| ? {if ($_.split(':')[1]){($_.split(':')[1]).trim() -notlike "-"} else {$_.trim()}} ) -join ";").trim() -replace "\\","\\"
		}
		"4740"{
			$change_obj = $event.split(";")[21]
		}
		"4781"{
			$change = ""
			$change_obj = (($event.split(";")[17..18]| ? {if ($_.split(':')[1]){($_.split(':')[1]).trim() -notlike "-"} else {$_.trim()}} ) -join ";").trim() -replace "\\","\\"
		}
		{($eventid_pol -contains $_)} {
			$change = $event.split(";")[20]
			$change = ($change.Substring(5)).trim()
			$change = (get-ADObject -Filter 'objectClass -eq "groupPolicyContainer" -and objectguid -eq $change' -Properties displayname).displayname
			$change_obj = $event.split(";")[27]
			$change_obj = ($change_obj.Substring(6)).trim()
			$change_obj_sct = $event.split(";")[25]
			$change_obj_sct = ($change_obj_sct.Substring(18)).trim()
			
			$change_obj	= ($change_obj.split('[{}]')| ? {$_.trim() -ne "" })[0]
			$registry_path = 'hklm:\software\Microsoft\Windows NT\CurrentVersion\Winlogon\GPExtensions\{' + $change_obj + '}'
			if (Test-Path $registry_path) {
				$change_obj = (Get-ItemProperty $registry_path)."(default)"
				$change_obj = $change_obj_sct + "/" + $change_obj
			}
			else {
				$change_obj ="---FilterThisEntry---"
			}
			
			$modifiedby = $event.split(";")[7]
			$modifiedby = ($modifiedby.Substring(13)).trim()
		}
		default {
				[void]$foreach.moveNext()
		}
	}
	if ((!(($change_obj -eq "") -and ($id -eq "4738"))) -and ($change_obj -notlike "---FilterThisEntry---") -and ($change_obj -notlike "gPC*ExtensionNames/")){
		$desc = $desc -replace "\'"," "
		
		$date_str = $date.split(" ")[0]
		$time_str = $date.split(" ")[1]
		#$date_newformat = $date_str.split(".")[2] + "-" + $date_str.split(".")[1] + "-" + $date_str.split(".")[0]
		# bug resolved by Camilo Santana. The timestamp was not displayed correctly (0000-00-00 00:00:00)
		$date_newformat = $date_str.split(".")[2] + "-" + $date_str.split(".")[0] + "-" + $date_str.split(".")[1]
		$datetime_new = $date_newformat + " " + $time_str

		$query = "INSERT INTO ad_events (evt_date,evt_id,evt_desc,evt_chg,evt_obj,evt_modby) VALUES('$datetime_new','$id','$desc','$change','$change_obj','$modifiedby')"
		$Rows = WriteMySQLQuery $conn $query
	}
}
$conn.close()
}